﻿<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>Примеры. Ломанная линия со стрелочками.</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta name="viewport" content="initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0 user-scalable=yes" />

    <script src="http://api-maps.yandex.ru/1.1/index.xml?key=AC25J08BAAAAwzsdYAMAf_snd4Vx9UuVWhj1n_Ni1yv0QWwAAAAAAAAAAABQM_gCuWQo9M1ix457N4Tas_JEtw==" type="text/javascript"></script>
    <script type="text/javascript">
        // Создание обработчика для события window.onLoad
        YMaps.jQuery(function () {
            // Создание экземпляра карты и его привязка к созданному контейнеру
			YMaps.jQuery("#YMapsID").width(window.innerWidth).height(window.innerHeight);
			YMaps.jQuery("body").css("margin", "0px");
            map = new YMaps.Map(YMaps.jQuery("#YMapsID")[0]);
			
            // Установка для карты ее центра и масштаба
            map.setCenter(new YMaps.GeoPoint(37.64, 55.76), 10);

            // Включение масштабирование колесиком мыши
            map.enableScrollZoom();

            // Создание стиля
            var style = new YMaps.Style("default#greenPoint");
            style.polygonStyle = new YMaps.PolygonStyle();
            style.polygonStyle.fillColor = "ff0000ff";
            style.lineStyle = new YMaps.LineStyle();
            style.lineStyle.strokeColor = "ff0000ff";
            style.lineStyle.strokeWidth = 3;
            YMaps.Styles.add("style#Example", style);

            // Создание ломанной со стрелочкам
            polyline = new PolylineCanvas([ 
                new YMaps.GeoPoint(37.600963,55.575358), new YMaps.GeoPoint(37.508095,55.596356), new YMaps.GeoPoint(37.435574,55.66045),
                new YMaps.GeoPoint(37.414553,55.685285), new YMaps.GeoPoint(37.385385,55.713877), new YMaps.GeoPoint(37.369431,55.745985),
                new YMaps.GeoPoint(37.369952,55.76645), new YMaps.GeoPoint(37.376554,55.794178), new YMaps.GeoPoint(37.397018,55.835862),
                new YMaps.GeoPoint(37.392517,55.849757), new YMaps.GeoPoint(37.400378,55.864414), new YMaps.GeoPoint(37.446695,55.882156),
                new YMaps.GeoPoint(37.478774,55.88562), new YMaps.GeoPoint(37.536023,55.907798), new YMaps.GeoPoint(37.590731,55.910397),
                new YMaps.GeoPoint(37.641432,55.897044), new YMaps.GeoPoint(37.704493,55.89294), new YMaps.GeoPoint(37.835378,55.827924),
                new YMaps.GeoPoint(37.846571,55.77758),  new YMaps.GeoPoint(37.830249,55.685899), new YMaps.GeoPoint(37.842627,55.655717),
                new YMaps.GeoPoint(37.766432,55.605648), new YMaps.GeoPoint(37.687812,55.574365), new YMaps.GeoPoint(37.600963,55.575358)
            ], {style: "style#Example"});

            // Добавление ломанной на карту
            map.addOverlay(polyline);
	
        })

        // Реализует наследование прототипа без исполнения конструктора родителя
        // Подробнее о наследовании: http://javascript.ru/tutorial/object/inheritance
        function extend (child, parent) {
            var c = function () {};
            c.prototype = parent.prototype;
            c.prototype.constructor = parent;
            return child.prototype = new c();
        };

        // Наследуемся от YMaps.Polyline
        function PolylineCanvas (points, options) {
            // Вызов родительского конструктора
            YMaps.Polyline.call(this, points, options);
			
			
			
			var sizeOfMap = map.getContainerSize();

			this._canvasPolyLine = YMaps.jQuery("<canvas></canvas>").
										attr("id", "id_canvas").	
										attr("width", sizeOfMap.x).
										attr("height", sizeOfMap.y).
										css("z-index", 50).
										css("position", "absolute").
										appendTo(".YMaps-layer-container").
										get(0);

			
			
			var CanvasLeave;
			var polyline = this;
			
			var listenerMapMove = YMaps.Events.observe(map, map.Events.Move, function (map) {		
				var needRedraw;
				if ( !polyline.IsFullDrawOnMapUpdate) 
				{	
					if ( needRedraw = polyline.CanvasNeedRedraw(polyline.getBounds()) ) 
					{			
						polyline._canvasPolyLine.style.left = 0 + "px";
						polyline._canvasPolyLine.style.top = 0 + "px";
						polyline.updateCanvas();
						CanvasLeave = true;
					}
					else
					{
						if ( CanvasLeave == true ) 
						{
							var rc = polyline._canvasPolyLine.getContext("2d");
							rc.clearRect(0,0, polyline._canvasPolyLine.width, polyline._canvasPolyLine.height);
							CanvasLeave = false;
						}
					}
				}
				else if ( polyline.IsFullDrawOnMapUpdate )  
				{ 
					polyline._canvasPolyLine.style.left = map._state.offset.x + "px";
					polyline._canvasPolyLine.style.top = map._state.offset.y + "px";						
				}
			});				
			var listenerMapMoveEnd = YMaps.Events.observe(map, map.Events.MoveEnd, function (map) {					
				if ( !polyline.IsFullDrawOnMapUpdate && polyline.CanvasNeedRedraw(polyline.getBounds()) ) 
				{			
					polyline._canvasPolyLine.style.left = 0 + "px";
					polyline._canvasPolyLine.style.top = 0 + "px";
					polyline.updateCanvas();
				}
				
			});	
			var listenerSmoothZoomStart =  YMaps.Events.observe(map, map.Events.SmoothZoomStart, function (map) {									
				var rc = polyline._canvasPolyLine.getContext("2d");
				rc.clearRect(0,0, polyline._canvasPolyLine.width, polyline._canvasPolyLine.height);
			});
			
            // Вызывается при добавлении объекта на карту
            this.onAddToMap = function (map, mapContainer) {
                YMaps.Polyline.prototype.onAddToMap.call(this, map);              

                // Добавление стрелочек на ломанную
                this.updateCanvas();				
				this.IsFullDrawOnMapUpdate = this._IsPolylineBoundSubsetMapBound();
            }
            // Вызывается при удалении объекта с карты
            this.onRemoveFromMap = function () {
                // Удаление ломанной с карты
                YMaps.Polyline.prototype.onRemoveFromMap.call(this);

                // Удаление обработчика событий                
				listenerMapMove.cleanup();
				listenerMapMoveEnd.cleanup();
				listenerSmoothZoomStart.cleanup();
				
				YMaps.jQuery("#id_canvas").remove();
            }
            // Вызывается при обновлении карты
            this.onMapUpdate = function () {
                // Обновление ломанной на карте
                YMaps.Polyline.prototype.onMapUpdate.call(this);
				
				
				this._canvasPolyLine.style.left = this._map._state.offset.x;
				this._canvasPolyLine.style.top = this._map._state.offset.y;
				
				var boundsPolyline = this.getBounds();
				var boundsMap = this.getMap().getBounds();
				

				this.IsFullDrawOnMapUpdate = this._IsPolylineBoundSubsetMapBound();


                var needRedraw = boundsMap.intersects(boundsPolyline);
				if ( needRedraw )
				{
					this.updateCanvas();
				}
				else
				{
					var rc = this._canvasPolyLine.getContext('2d');
					rc.clearRect(0,0,this._canvasPolyLine.width, this._canvasPolyLine.height);
				}
				//this._drawBound(boundsMap);
				//this._drawBound(boundsPolyline);				
				console.log("IsFullDrawOnMapUpdate: " + this.IsFullDrawOnMapUpdate);
            }
			
			this._drawBound = function(bounds){
				var rc = this._canvasPolyLine.getContext("2d");
				rc.beginPath();				
				var current = this.getMap().converter.coordinatesToMapPixels(bounds.getLeftTop());				
				rc.moveTo(current.x, current.y);
				current = this.getMap().converter.coordinatesToMapPixels(bounds.getRightTop());
				rc.lineTo(current.x, current.y);
				current = this.getMap().converter.coordinatesToMapPixels(bounds.getRightBottom());
				rc.lineTo(current.x, current.y);
				current = this.getMap().converter.coordinatesToMapPixels(bounds.getLeftBottom());
				rc.lineTo(current.x, current.y);
				current = this.getMap().converter.coordinatesToMapPixels(bounds.getLeftTop());
				rc.lineTo(current.x, current.y);
				rc.stroke();
				rc.closePath();
				
			}
			this._IsPolylineBoundSubsetMapBound = function(){
				var boundsPolyline = this.getBounds();
				var boundsMap = this.getMap().getBounds();
				
				if ( boundsMap.getLeft() < boundsPolyline.getLeft() &&
					 boundsMap.getRight() > boundsPolyline.getRight() &&
					 boundsMap.getTop() > boundsPolyline.getTop() &&
					 boundsMap.getBottom() < boundsPolyline.getBottom() )
					return true;
				else 
					return false;

			}
			this._IsPolylineBoundSubsetMapBoundInPixel = function(boundsPolyline){
				var LeftTop = this.getMap().converter.coordinatesToMapPixels(boundsPolyline.getLeftTop());				
				var RightBottom = this.getMap().converter.coordinatesToMapPixels(boundsPolyline.getRightBottom());
				sizeMap = this.getMap().getContainerSize();
				if ( LeftTop.x < -1 || LeftTop.y < -1 || RightBottom.x > (sizeMap.x + 1) || RightBottom.y > (sizeMap + 1)  ) 
					return false;
				else 
					return true;
			}
			this.CanvasNeedRedraw = function(geoBoundsCanvas){
				return this.getMap().getBounds().intersects( geoBoundsCanvas ) ;				
			}            
            this.updateCanvas = function () {				
				var rc= this._canvasPolyLine.getContext('2d');
				rc.clearRect(0,0, this._canvasPolyLine.width, this._canvasPolyLine.height);
				rc.beginPath();
				rc.save();
				rc.translate(this.getMap()._state.offset.x, this.getMap()._state.offset.y);
                for (var i = 0, prev, current, points = this.getPoints(); i < points.length; i++) {
                    // Пиксельные кординаты
                    current = this.getMap().converter.coordinatesToMapPixels(points[i]);
                    if (prev) {
                        // Вектор
						rc.lineTo(current.getX(), current.getY());
                    }
					else {
						rc.moveTo(current.getX(), current.getY());
					}
                    prev = current;
                }
				rc.stroke();
				rc.closePath();
				rc.restore();
            };
			this.getBounds = function(){							

				var leftCoord, rightCoord, topCoord, bottomCoord;
				rightCoord = topCoord = Number.NEGATIVE_INFINITY;
				leftCoord = bottomCoord = Number.POSITIVE_INFINITY;
								
				for (var i = 0, points = this.getPoints(); i < points.length; i++) {
                    if (points[i].getX() > rightCoord){                        
						rightCoord =  points[i].getX();
					}
                    if ( points[i].getX() < leftCoord ) {
						leftCoord = points[i].getX();
					}
					if ( points[i].getY() < bottomCoord ) {
						bottomCoord = points[i].getY();
					}
					if ( points[i].getY() > topCoord ) {
						topCoord = points[i].getY();
					}
                }
				var geoBoundCanvas = new YMaps.GeoBounds(new YMaps.GeoPoint( leftCoord, bottomCoord ) , new YMaps.GeoPoint( rightCoord, topCoord ) );
				return geoBoundCanvas;
			};


        }
		

		
        var ptp = extend(PolylineCanvas, YMaps.Polyline);
		
		
    </script>
</head>

<body>	
    <div id="YMapsID" style="width:600px;height:600px">		
	</div>
</body>

</html>
